using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_CRM._0_Modelos;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_CRM._1_Datos
{
    public class CRM_Acciones_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_CRM_Acciones_Listado_Modelo> g_lst_INTERNO_CRM_Acciones_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CRM_Acciones).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CRM_Acciones_Listado_Modelo != null) && (g_lst_INTERNO_CRM_Acciones_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_CRM_Acciones_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CRM_Acciones).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CRM_Acciones_Listado_Modelo != null) && (g_lst_INTERNO_CRM_Acciones_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_CRM_Acciones_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_CRM_Acciones_Listado_Modelo.id) + " = " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.id) + "," +
                          nameof(INTERNO_CRM_Acciones_Listado_Modelo.codigo) + " = " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.codigo) + "," +
                          nameof(INTERNO_CRM_Acciones_Listado_Modelo.descripcion) + " = " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.descripcion) + "," +
                          //ids
                          nameof(INTERNO_CRM_Acciones_Listado_Modelo.idEmpresa) + " = " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.idEmpresa) + "," +
                          //Empresa
                          (
                            (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa)))
                              ?
                                  (
                                      nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                      nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa_Descripcion) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                      nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa_FechaBorrado) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado)  
                                  )
                              :
                                  (
                                      nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                      nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                      nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa_FechaBorrado) + " = NULL "
                                  )
                          ) +
                    " FROM " + nameof(CRM_Acciones) +
                        //Empresa
                        (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CRM_Acciones_Listado_Modelo.Empresa)))
                                ?
                                    (
                                     " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                    )
                                : ("")
                        ) +
                    " WHERE " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.fechaBorrado) + " IS null AND " +
                            " ( " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                        ? (" OR " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                            (_lng_id > -1 ? nameof(CRM_Acciones) + "." + (nameof(CRM_Acciones.id) + "=@id ") : " 1 = 1 ");

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_CRM_Acciones_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CRM_Acciones_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_CRM_Acciones_Listado_Modelo g_mdl_INTERNO_CRM_Acciones_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CRM_Acciones).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_CRM_Acciones_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_CRM_Acciones_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CRM_Acciones).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_CRM_Acciones_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_CRM_Acciones_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                string str_SQL =
                     " SELECT distinct " +
                         nameof(INTERNO_CRM_Acciones_Listado_Modelo.id) + " = " + nameof(CRM_Acciones.id) + "," +
                         nameof(INTERNO_CRM_Acciones_Listado_Modelo.codigo) + " = " + nameof(CRM_Acciones.codigo) + "," +
                         nameof(INTERNO_CRM_Acciones_Listado_Modelo.descripcion) + " = " + nameof(CRM_Acciones.descripcion) +
                     " FROM " + nameof(CRM_Acciones) +
                      " WHERE " + nameof(CRM_Acciones.fechaBorrado) + " IS null AND " +
                           " ( " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                        ? (" OR " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                          (
                           (_lng_id > -1)
                             ? (nameof(CRM_Acciones.id) + " = " + _lng_id)
                             : (
                                  //Filtrar por Codigo
                                  (_str_CampoBusqueda.Equals(nameof(CRM_Acciones.codigo)))
                                      ? (nameof(CRM_Acciones.codigo) + "=@Filtro")
                                      //Filtrar por Nombre
                                      : (nameof(CRM_Acciones.descripcion) + "=@Filtro")
                               )
                          );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_CRM_Acciones_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CRM_Acciones_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                $@" SELECT 
                      {nameof(CRM_Acciones.id)},
                      {nameof(CRM_Acciones.codigo)},
                      {nameof(CRM_Acciones.idEmpresa)},
                      {nameof(CRM_Acciones.observaciones)},
                      {nameof(CRM_Acciones.descripcion)},
                      {nameof(CRM_Acciones.fechaBorrado)}
                FROM {nameof(CRM_Acciones)}
                WHERE {nameof(CRM_Acciones.id)} = @id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<CRM_Acciones>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private CRM_Acciones g_mdl_CRM_Acciones = null;
        public CRM_Acciones Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.fechaBorrado) + " IS NULL AND " +
                                             nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CRM_Acciones;
        }


        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                            object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CRM_Acciones = obj_Exferia_Entities.Database.SqlQuery<CRM_Acciones>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        #region ModeloListado
        private List<CRM_Acciones> g_lst_CRM_Acciones = null;

        public List<CRM_Acciones> Obtener_ModeloListado()
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(CRM_Acciones) + "." + nameof(CRM_Acciones.fechaBorrado) + " IS NULL ";

                //Parametros
                object[] arr_Parametros = new object[1];

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_ModeloListado), true);
            }

            return g_lst_CRM_Acciones;
        }

        public List<CRM_Acciones> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {

                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(CRM_Acciones),
                                                                                            nameof(CRM_Acciones.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });

                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_CRM_Acciones;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_CRM_Acciones = obj_Exferia_Entities.Database.SqlQuery<CRM_Acciones>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion


        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CRM_Acciones.id) + " , " +
                    nameof(CRM_Acciones.idEmpresa) + " , " +
                    nameof(CRM_Acciones.codigo) + " , " +
                    nameof(CRM_Acciones.descripcion) + " , " +
                    nameof(CRM_Acciones.observaciones) + " , " +
                    nameof(CRM_Acciones.fechaBorrado) +
                " FROM " + nameof(CRM_Acciones);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;
                obj_Exferia_Entities.Configuration.ProxyCreationEnabled = true;

                CRM_Acciones mdl_CRM_Acciones_AGrabar = (CRM_Acciones)_mdl_obj;
                CRM_Acciones mdl_CRM_Acciones_DatosViejos = new CRM_Acciones();

                // Ver si existe ######################################################################
                CRM_Acciones mdl_CRM_Acciones_Final = Obtener_Modelo_Por_Id(mdl_CRM_Acciones_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_CRM_Acciones_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CRM_Acciones_Final, mdl_CRM_Acciones_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CRM_Acciones_AGrabar, mdl_CRM_Acciones_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CRM_Acciones) +
                                            " SET " +
                                                nameof(CRM_Acciones.codigo) + "=@codigo," +
                                                nameof(CRM_Acciones.descripcion) + "=@descripcion," +
                                                nameof(CRM_Acciones.idEmpresa) + "=@idEmpresa," +
                                                nameof(CRM_Acciones.observaciones) + "=@observaciones," +
                                                nameof(CRM_Acciones.fechaBorrado) + "=@fechaBorrado" +
                                            " WHERE " +
                                                nameof(CRM_Acciones.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_CRM_Acciones_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_CRM_Acciones_Final.descripcion),
                        new SqlParameter("@idEmpresa",  mdl_CRM_Acciones_Final.idEmpresa),
                        mdl_CRM_Acciones_Final.observaciones != null
                            ?   new SqlParameter("@observaciones", mdl_CRM_Acciones_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                         mdl_CRM_Acciones_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_CRM_Acciones_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id", mdl_CRM_Acciones_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CRM_Acciones_Final.id;
                }
                //INSERT
                else
                {
                    mdl_CRM_Acciones_Final = new CRM_Acciones();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CRM_Acciones_AGrabar, mdl_CRM_Acciones_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CRM_Acciones) +
                                                " (" +
                                                        nameof(CRM_Acciones.codigo) + " , " +
                                                        nameof(CRM_Acciones.descripcion) + " , " +
                                                        nameof(CRM_Acciones.idEmpresa) + " , " +
                                                        nameof(CRM_Acciones.observaciones) + " , " +
                                                        nameof(CRM_Acciones.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(CRM_Acciones.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@codigo," +
                                                    "@descripcion," +
                                                    "@idEmpresa," +
                                                    "@observaciones," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_CRM_Acciones_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_CRM_Acciones_Final.descripcion),
                        new SqlParameter("@idEmpresa",  mdl_CRM_Acciones_Final.idEmpresa),
                        mdl_CRM_Acciones_Final.observaciones != null
                            ?   new SqlParameter("@observaciones", mdl_CRM_Acciones_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                         mdl_CRM_Acciones_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_CRM_Acciones_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CRM_Acciones), mdl_CRM_Acciones_DatosViejos, mdl_CRM_Acciones_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CRM_Acciones mdl_CRM_Acciones_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_CRM_Acciones_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CRM_Acciones) +
                                                " SET " +
                                                nameof(CRM_Acciones.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(CRM_Acciones.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(CRM_Acciones), null, mdl_CRM_Acciones_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CRM_Acciones_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
